﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;

namespace RadPropertyGridBoundToDataTable
{
    public class MyCustomTypeDescriptor : CustomTypeDescriptor
    {
        private DataTable table;

        public MyCustomTypeDescriptor(DataTable table)
        {
            this.table = table;
        }

        public override PropertyDescriptorCollection GetProperties()
        {
            List<MyPropertyDescriptor> properties = new List<MyPropertyDescriptor>();

            foreach (DataRow row in table.Rows)
            {
                MyPropertyDescriptor descriptor = new MyPropertyDescriptor(row);
                properties.Add(descriptor);
            }

            return new PropertyDescriptorCollection(properties.ToArray());
        }

        public override PropertyDescriptorCollection GetProperties(Attribute[] attributes)
        {
            return this.GetProperties();
        }
    }
}
