﻿using System;
using System.ComponentModel;
using System.Data;
using System.Linq;

namespace RadPropertyGridBoundToDataTable
{
    public class MyPropertyDescriptor : PropertyDescriptor
    {
        private DataRow row;

        public MyPropertyDescriptor(DataRow row)
            : base(row["Name"].ToString(),                  //DESCRIPTION Added a description attribute.
            new Attribute[] { new BrowsableAttribute(true), new DescriptionAttribute(row["Description"].ToString()) })
        {
            this.row = row;
        }

        public override bool CanResetValue(object component)
        {
            return false;
        }

        public override Type ComponentType
        {
            get 
            { 
                return typeof(DataTable);
            }
        }

        public override object GetValue(object component)
        {
            return row["Value"];
        }

        public override bool IsReadOnly
        {
            get 
            {
                return false;
            }
        }

        public override Type PropertyType
        {
            get
            {
                return row["Value"].GetType();
            }
        }

        public override void ResetValue(object component)
        {
            
        }

        public override void SetValue(object component, object value)
        {
            this.row["Value"] = value;
        }

        public override bool ShouldSerializeValue(object component)
        {
            return true;
        }
    }
}
